socket_accept4_setcloseonexec(3)

NAME
socket_accept4_setcloseonexec - accept an IPv4 TCP connection on a socket and set it to close on exec

SYNTAX
#include <libowfat/socket.h>

int socket_accept4_setcloseonexec(int s,char ip[4],uint16 *port);

DESCRIPTION
This is functionally equivalent to calling socket_accept4 and then calling io_closeonexec on the returned socket.

However, if may save a syscall or two and in the process avoid a race condition.

EXAMPLE
  #include <libowfat/socket.h>

  int s;
  char ip[4];
  uint16 p;

  s = socket_tcp4();
  socket_bind4(s,ip,p);
  socket_listen(s,16);
  socket_accept4_setcloseonexec(s,ip,&p);

SEE ALSO
socket_accept4(3), socket_connected(3), socket_accept6_setcloseonexec(3), socket_accept4_makenonblocking_setcloseonexec(3)